#!perl
###############################################################################
# Author: Francis Turner	Date: 29 June 2005
# (c) Francis Turner 2005
# Version 1.1
#
# Author contact information at http://www.di2.nu/content.htm
# Latest versions etc. of this files at http://www.di2.nu/software/index.htm
#
# These files are released under the Creative Commons Attribution-NonCommercial
# ShareAlike License. http://creativecommons.org/licenses/by-nc-sa/2.5/
#
# This script is used to update the ebook list. The basic assumptions are that
# 1) all your ebooks stored in subdirectories of a single directory,
# 2) you have a webserver running with perl & CGI enabled and that the ebook
#    place on the webserver is the same as the directory name (i.e. 
#    http://localhost/ebooks refers to directory /ebooks )
# 3) eBooks are Baen style ones with a main page called [ISBN].htm
# the whole of (2) other than the perl requirement is optional if you make some
# changes to this file.
# No checking of permissions or authenication is performed. You may wish to 
# change this if your webserver is publically accessable.
# Under no circumstances will the author accept any liablity for data loss
# caused by the execution of this program. 
#
# Version 1.0	Intial public release 
# Version 1.1	Modification to the DHTML/Javascript to alter the way columns 
#		are created and to remember which author's have been opened
###############################################################################

use CGI ':standard'; # CGI.PM is used to create the file as well as to print the results
use CGI::Carp qw/fatalsToBrowser/;
use File::DosGlob;

my $fn =  '/ebooks/*'; # base directory - you may need to change this
my $htmlfn = '/ebooks/ebooksample.htm'; # file name for the index file - usually /ebooks/index.htm

print header, start_html('Ebook Updating Thingy'),
    h1('Ebook Updater'),
    'Result:<pre>';
# First step find the books
undef $/;
my %h; # hash of books to authors
# note we push the href to the book & title onto an array for each author
my %hh; # hash of author names to get the best one(s)

my @m = File::DosGlob::doglob(1,$fn); # this is a possibly ugly hack a regular glob should work too
for (@m) {
    push @m, File::DosGlob::doglob(1,$_.'/*') if -d($_); # add subdirectory contents to array
    next unless /\d[\dX]{8}\.htm$/; # look for files with ISBN/DOI number only
    $fn = $_; # modify this line if the web absolute URL is not the same as the path
              # e.g. if the base directors $fn above is "c:/www/ebooks" and the access URL is just 
              # http://localhost/ebooks/ then you would have a $fn=substr($_,6);

    open (FILE, "<$_");
    my $l = <FILE>; # slurp in the file
    close(FILE);
    # The book title and all author names are embadded in the <title> section which ends
    # "- Baen Books</title>" this regex extracts the title and author names
    $l=~m!<title>([^<]+?) by ([^<]+?)\.?\s+- Baen!s;
    my ($t, $l) = ($1, $2);
    for (split(/\s*(?:,|&amp;)\s*/, $l)) { # break the author list down into individual author
	my $i = index($_,' ');
	my $j = index(substr($_,0,$i),'.');
	print "$_,$i,$j\n";
	my $k = substr($_,0,(($j>0)?$j:$i)).substr($_,rindex($_,' '));
	$hh{$k}=$_ if (length ($_)> length($hh{$k}));
	push @{$h{$k}},a({href=>$fn},$t);
    }
}

open (FILE, "<$htmlfn"); # read in original HTML file to extract top and tail
# might want to have an error of file not found?
my $tplt = <FILE>;
close(FILE);
open (OFILE, ">$htmlfn"); # same fn as above unless you want a backup copy

print OFILE substr($tplt,0,index($tplt,'EOHDR')).'EOHDR
-->';

for $author (sort {substr($a,rindex($a,' '))cmp substr($b,rindex($b,' '))} keys %h) {
    print OFILE '<div class="au">'.p({onclick=>"au('$author');"},$hh{$author})."<ul style='display: none;' id='$author'>\n";
    for (sort {substr($a,index($a,'>')-15)cmp substr($b,index($b,'>')-15)} @{$h{$author}}) {
	if (substr($_,index($_,'>')) eq $l) { print OFILE substr($_,0,index($_,'>')+1)."*</a>\n"; }
	else { print OFILE "<li>$_\n"; $l=substr($_,index($_,'>')), }
    }
    print OFILE "</ul></div>\n";
}
print OFILE '</div><div id="end">'.hr.a({href=>url(-absolute=>1)},"Update this eBook list").
'<br>
<!-- Creative Commons License -->
<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.gif" /></a><br />
This ebook index is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.5/">Creative Commons Attribution-NonCommercial-ShareAlike 2.5 License</a>.
<!-- /Creative Commons License -->
<!--
<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <license rdf:resource="http://creativecommons.org/licenses/by-nc-sa/2.5/" />
</Work>
<License rdf:about="http://creativecommons.org/licenses/by-nc-sa/2.5/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>
</rdf:RDF>
-->
<br>Original code and updates <a href="http://www.di2.nu/software/index.htm">available here</a> This is version 1.1
</div>
</body></html>';
close OFILE;
print "\n</pre><br>Go to ".a({href=>"$htmlfn"},'Updated Ebook Index' ).end_html;
